# -*- coding:utf-8 -*- 
#
# Copyright(C) 2014 Laurent Faipot (laurent.faipot@free.fr). All rights reserved.
#

import imp
import os

from error import Error
from memory import Memory   
from config import Config
from controller import Controller

class Board:
    
    def __init__(self, display, arch):
        archDir = Config.getArchDir()
        self.display = display
        archPath = os.path.join(archDir, "arch_" + arch + ".py")
        print "ARCH FILE: " + archPath
        self.arch = imp.load_source(arch, archPath)
        self.chip = self.arch.Chip()
        self.controller = Controller()
        self.memory = Memory(self, self.arch.Architecture.memorySize)
        self.memory.addController(self.controller)
 
    def loadProgram(self, fileName):
        try:
            self.program = self.arch.Program()
            self.program.load(fileName, self)
        except Error, e:
            e.display()
            return False
        else:
            return True

    