# -*- coding:utf-8 -*- 
#
# Copyright(C) 2014 Laurent Faipot (laurent.faipot@free.fr). All rights reserved.
#

# temporary
from led import *

class Controller:
    
    __name    = 0
    __address = 1
    __size    = 2
    __fct     = 3
    
    def __init__(self):
        self.deviceList = []
        # temporary
        self.led = Led(self)
    
    def declareInput(self, name, address, size, fct):
        self.deviceList.append([name, address, size, fct])
        
    def callInput(self, memory, address, size):
        for device in self.deviceList:          
            impacted = False
              
            # check if the device is impacted by memory update
            for i in range(size):
                if device[Controller.__address] <= address + i < (device[Controller.__address] + device[Controller.__size]):
                    impacted = True
                    break
            
            if impacted:
            # create a buffer to communicate with the device
            # Note that changed memory area could not match exactly
            # device input boundaries then initialize a buffer with required memory content
                data = bytearray([device[Controller.__size]])
                for i in range(device[Controller.__size]):
                    b = memory.get(device[Controller.__address], 1)
                        
                    data[i] = memory.get(device[Controller.__address], 1)
                device[Controller.__fct](device[Controller.__address], device[Controller.__size], data)
            
