# -*- coding:utf-8 -*- 
#
# Copyright(C) 2014 Laurent Faipot (laurent.faipot@free.fr). All rights reserved.
#

import os
from PyQt4 import QtGui
from ledUI import Ui_ledWidget
from controller import *

class Led(QtGui.QMainWindow, Ui_ledWidget):
    
    def __init__(self, controller, parent=None):
        print "LED ----> init"
        super(Led, self).__init__(parent)
        self.setupUi(self)
        self.show()
        
        devicePath = os.path.dirname(os.path.abspath(__file__))
        self.onFile = os.path.join(devicePath, "yellow-on-32.png")
        self.offFile = os.path.join(devicePath, "yellow-off-32.png")
        print "file : " + self.offFile

        # declare itself to Board controller
        controller.declareInput("LED", 50, 1, self.changeInput)
        self.led = []
        startX = 40
        sizeLed = 32
        filler = 10
        for i in range(8):
            led = QtGui.QLabel(self)
            led.setGeometry(startX + ((7 - i) * (sizeLed + filler)), 10, 400, 100)
            #use full ABSOLUTE path to the image, not relative
            led.setPixmap(QtGui.QPixmap(self.offFile))
            led.show()
            self.led.append(led)
        self.resize((sizeLed + filler) * 8 + 80 ,120)
        
        screen = QtGui.QDesktopWidget().screenGeometry()
        window = self.geometry()
        self.move((screen.width()-window.width())/2, (screen.height()-window.height())/2)
        

        
    def changeInput(self, address, size, data):
        print "LED ----------> address: " + str(address) + " size: " + str(size) + " --> value " + str(hex(data[0]))
        value = data[0]

        for i in range(8):
            mask = 1 << i
            if (value & mask):
                self.led[i].setPixmap(QtGui.QPixmap(self.onFile))
            else:
                self.led[i].setPixmap(QtGui.QPixmap(self.offFile))
     
